/*
 Copyright (c) 2018, Ford Motor Company
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following
 disclaimer in the documentation and/or other materials provided with the
 distribution.

 Neither the name of the Ford Motor Company nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef SRC_COMPONENTS_APPLICATION_MANAGER_RPC_PLUGINS_RC_RPC_PLUGIN_INCLUDE_RC_RPC_PLUGIN_RC_MODULE_CONSTANTS_H_
#define SRC_COMPONENTS_APPLICATION_MANAGER_RPC_PLUGINS_RC_RPC_PLUGIN_INCLUDE_RC_RPC_PLUGIN_RC_MODULE_CONSTANTS_H_

namespace rc_rpc_plugin {

namespace strings {
// RemoteControlCapabilities constants
const char kclimateControlCapabilities[] = "climateControlCapabilities";
const char kradioControlCapabilities[] = "radioControlCapabilities";
const char kbuttonCapabilities[] = "buttonCapabilities";
const char kaudioControlCapabilities[] = "audioControlCapabilities";
const char klightControlCapabilities[] = "lightControlCapabilities";
const char khmiSettingsControlCapabilities[] = "hmiSettingsControlCapabilities";
const char kseatControlCapabilities[] = "seatControlCapabilities";
// RemoteControlCapabilities constants

const char kServiceArea[] = "serviceArea";
const char kLocation[] = "location";
const char kCol[] = "col";
const char kRow[] = "row";
const char kLevel[] = "level";
const char kColspan[] = "colspan";
const char kRowspan[] = "rowspan";
const char kLevelspan[] = "levelspan";

// SeatLocationCapability constants
const char kCols[] = "columns";
const char kRows[] = "rows";
const char kLevels[] = "levels";
const char kSeats[] = "seats";
const char kGrid[] = "grid";
// SeatLocationCapability constants

const char kAllowMultipleAccess[] = "allowMultipleAccess";

// ClimateControlCapabilities
const char kFanSpeedAvailable[] = "fanSpeedAvailable";
const char kCurrentTemperatureAvailable[] = "currentTemperatureAvailable";
const char kDesiredTemperatureAvailable[] = "desiredTemperatureAvailable";
const char kAcEnableAvailable[] = "acEnableAvailable";
const char kCirculateAirEnableAvailable[] = "circulateAirEnableAvailable";
const char kAutoModeEnableAvailable[] = "autoModeEnableAvailable";
const char kDefrostZoneAvailable[] = "defrostZoneAvailable";
const char kDualModeEnableAvailable[] = "dualModeEnableAvailable";
const char kAcMaxEnableAvailable[] = "acMaxEnableAvailable";
const char kVentilationModeAvailable[] = "ventilationModeAvailable";
const char kHeatedSteeringWheelAvailable[] = "heatedSteeringWheelAvailable";
const char kHeatedWindshieldAvailable[] = "heatedWindshieldAvailable";
const char kHeatedMirrorsAvailable[] = "heatedMirrorsAvailable";
const char kHeatedRearWindowAvailable[] = "heatedRearWindowAvailable";

// LightControlCapabilities
const char kName[] = "name";
const char kStatusAvailable[] = "statusAvailable";
const char kDensityAvailable[] = "densityAvailable";
const char kRGBColorSpaceAvailable[] = "rgbColorSpaceAvailable";
const char kSupportedLights[] = "supportedLights";

// RadioControlCapabilities
const char kRadioBandAvailable[] = "radioBandAvailable";
const char kRadioFrequencyAvailable[] = "radioFrequencyAvailable";
const char kRdsDataAvailable[] = "rdsDataAvailable";
const char kAvailableHDsAvailable[] = "availableHDsAvailable";
const char kHdRadioEnableAvailable[] = "hdRadioEnableAvailable";
const char kSignalStrengthAvailable[] = "signalStrengthAvailable";
const char kSignalChangeThresholdAvailable[] = "signalChangeThresholdAvailable";
const char kRadioEnableAvailable[] = "radioEnableAvailable";
const char kStateAvailable[] = "stateAvailable";
const char kSisDataAvailable[] = "sisDataAvailable";
const char kHdChannelAvailable[] = "hdChannelAvailable";

const char kSiriusxmRadioAvailable[] = "siriusxmRadioAvailable";

// SeatControlCapabilities
const char kHeatingEnabledAvailable[] = "heatingEnabledAvailable";
const char kCoolingEnabledAvailable[] = "coolingEnabledAvailable";
const char kHeatingLevelAvailable[] = "heatingLevelAvailable";
const char kCoolingLevelAvailable[] = "coolingLevelAvailable";
const char kHorizontalPositionAvailable[] = "horizontalPositionAvailable";
const char kVerticalPositionAvailable[] = "verticalPositionAvailable";
const char kFrontVerticalPositionAvailable[] = "frontVerticalPositionAvailable";
const char kBackVerticalPositionAvailable[] = "backVerticalPositionAvailable";
const char kBackTiltAngleAvailable[] = "backTiltAngleAvailable";
const char kHeadSupportHorizontalPositionAvailable[] =
    "headSupportHorizontalPositionAvailable";
const char kHeadSupportVerticalPositionAvailable[] =
    "headSupportVerticalPositionAvailable";
const char kMassageEnabledAvailable[] = "massageEnabledAvailable";
const char kMassageModeAvailable[] = "massageModeAvailable";
const char kMassageCushionFirmnessAvailable[] =
    "massageCushionFirmnessAvailable";
const char kMemoryAvailable[] = "memoryAvailable";

// AudioControlCapabilities
const char kSourceAvailable[] = "sourceAvailable";
const char kKeepContextAvailable[] = "keepContextAvailable";
const char kVolumeAvailable[] = "volumeAvailable";
const char kEqualizerAvailable[] = "equalizerAvailable";
const char kEqualizerMaxChannelId[] = "equalizerMaxChannelId";

// HmiSettingsCapabilities
const char kDistanceUnitAvailable[] = "distanceUnitAvailable";
const char kTemperatureUnitAvailable[] = "temperatureUnitAvailable";
const char kDisplayModeUnitAvailable[] = "displayModeUnitAvailable";

}  // namespace strings

namespace result_codes {
const char kSuccess[] = "SUCCESS";
const char kUnsupportedRequest[] = "UNSUPPORTED_REQUEST";
const char kUnsupportedResource[] = "UNSUPPORTED_RESOURCE";
const char kDisallowed[] = "DISALLOWED";
const char kRejected[] = "REJECTED";
const char kAborted[] = "ABORTED";
const char kIgnored[] = "IGNORED";
const char kRetry[] = "RETRY";
const char kInUse[] = "IN_USE";
const char kVehicleDataNotAvailable[] = "VEHICLE_DATA_NOT_AVAILABLE";
const char kTimedOut[] = "TIMED_OUT";
const char kInvalidData[] = "INVALID_DATA";
const char kCharLimitExceeded[] = "CHAR_LIMIT_EXCEEDED";
const char kInvalidId[] = "INVALID_ID";
const char kDuplicateName[] = "DUPLICATE_NAME";
const char kApplicationNotRegistered[] = "APPLICATION_NOT_REGISTERED";
const char kOutOfMemory[] = "OUT_OF_MEMORY";
const char kTooManyPendingRequests[] = "TOO_MANY_PENDING_REQUESTS";
const char kWarnings[] = "WARNINGS";
const char kWrongLanguage[] = "WRONG_LANGUAGE";
const char kGenericError[] = "GENERIC_ERROR";
const char kUserDisallowed[] = "USER_DISALLOWED";
const char kReadOnly[] = "READ_ONLY";
}  // namespace result_codes

namespace json_keys {
const char kParams[] = "params";
const char kSuccess[] = "success";
const char kResultCode[] = "resultCode";
const char kResult[] = "result";
const char kInfo[] = "info";
const char kId[] = "id";
const char kJsonrpc[] = "jsonrpc";
const char kMethod[] = "method";
const char kError[] = "error";
const char kMessage[] = "message";
const char kData[] = "data";
const char kAppId[] = "appID";
const char kCode[] = "code";
}  // namespace json_keys

namespace message_params {
const char kName[] = "name";
const char kId[] = "id";

// RCConsentManager, ResumptionCtrl, GetInteriorVehicleDataConsent request
const char kModuleId[] = "moduleId";
const char kModuleInfo[] = "moduleInfo";
const char kAppConsents[] = "appConsents";
const char kAppConsentList[] = "appConsentsList";
const char kConsent[] = "consent";
const char kConsentDate[] = "consentDate";
const char kModuleConsents[] = "moduleConsents";
const char kAppId[] = "appId";
const char kModuleIds[] = "moduleIds";
const char kMacAddress[] = "macAddress";
const char kApplications[] = "applications";
// RCConsentManager, ResumptionCtrl, GetInteriorVehicleDataConsent request

// SetInteriorVehicleData request
const char kModuleData[] = "moduleData";
// SetInteriorVehicleData request

// GetInteriorVehicleData request
const char kSubscribe[] = "subscribe";
// GetInteriorVehicleData request

// GetInteriorVehicleData response
const char kIsSubscribed[] = "isSubscribed";
// GetInteriorVehicleData response

// OnRemoteControlSettings notification
const char kAccessMode[] = "accessMode";
const char kAllowed[] = "allowed";
// OnRemoteControlSettings notification

// ButtonPress request
const char kModuleType[] = "moduleType";
const char kButtonName[] = "buttonName";
const char kButtonPressMode[] = "buttonPressMode";
// ButtonPress request

// OnRCStatusNotification
const char kAllocatedModules[] = "allocatedModules";
const char kFreeModules[] = "freeModules";
// OnRCStatusNotification

// RdsData struct
const char kPS[] = "PS";
const char kRT[] = "RT";
const char kCT[] = "CT";
const char kPI[] = "PI";
const char kPTY[] = "PTY";
const char kTA[] = "TA";
const char kTP[] = "TP";
const char kREG[] = "REG";
// RdsData struct

// RadioControlData struct
const char kFrequencyInteger[] = "frequencyInteger";
const char kFrequencyFraction[] = "frequencyFraction";
const char kBand[] = "band";
const char kRdsData[] = "rdsData";
const char kHdRadioEnable[] = "hdRadioEnable";
const char kAvailableHDs[] = "availableHDs";
const char kAvailableHdChannels[] = "availableHdChannels";
const char kAvailableHdChannelsAvailable[] = "availableHdChannelsAvailable";
const char kHdChannel[] = "hdChannel";
const char kSignalStrength[] = "signalStrength";
const char kSignalChangeThreshold[] = "signalChangeThreshold";
const char kRadioEnable[] = "radioEnable";
const char kState[] = "state";
const char kSisData[] = "sisData";
// RadioControlData struct

// ClimateControlData struct
const char kFanSpeed[] = "fanSpeed";
const char kCurrentTemperature[] = "currentTemperature";
const char kDesiredTemperature[] = "desiredTemperature";
const char kTemperatureUnit[] = "temperatureUnit";
const char kACEnable[] = "acEnable";
const char kCirculateAirEnable[] = "circulateAirEnable";
const char kAutoModeEnable[] = "autoModeEnable";
const char kDefrostZone[] = "defrostZone";
const char kDualModeEnable[] = "dualModeEnable";
const char kACMaxEnable[] = "acMaxEnable";
const char kVentilationMode[] = "ventilationMode";
const char kHeatedSteeringWheelEnable[] = "heatedSteeringWheelEnable";
const char kHeatedWindshieldEnable[] = "heatedWindshieldEnable";
const char kHeatedRearWindowEnable[] = "heatedRearWindowEnable";
const char kHeatedMirrorsEnable[] = "heatedMirrorsEnable";
const char kClimateEnable[] = "climateEnable";
const char kClimateEnableAvailable[] = "climateEnableAvailable";
// ClimateControlData struct

// SeatControlData
const char kHeatingEnabled[] = "heatingEnabled";
const char kCoolingEnabled[] = "coolingEnabled";
const char kHeatingLevele[] = "heatingLevel";
const char kCoolingLevel[] = "coolingLevel";
const char kHorizontalPosition[] = "horizontalPosition";
const char kVerticalPosition[] = "verticalPosition";
const char kFrontVerticalPosition[] = "frontVerticalPosition";
const char kBackVerticalPosition[] = "backVerticalPosition";
const char kBackTiltAngle[] = "backTiltAngle";
const char kHeadSupportHorizontalPosition[] = "headSupportHorizontalPosition";
const char kHeadSupportVerticalPosition[] = "headSupportVerticalPosition";
const char kMassageEnabled[] = "massageEnabled";
const char kMassageMode[] = "massageMode";
const char kMassageCushionFirmness[] = "massageCushionFirmness";
const char kMemory[] = "memory";

// LightControlData
const char kLightState[] = "lightState";
const char kLightStatus[] = "status";
const char kLightDensity[] = "density";
const char kLightColor[] = "color";

// AudioControlData
const char kSource[] = "source";
const char kVolume[] = "volume";
const char kKeepContext[] = "keepContext";
const char kEqualizerSettings[] = "equalizerSettings";
const char kChannelName[] = "channelName";

// HmiSettingsControlData
const char kDistanceUnit[] = "distanceUnit";
const char kDisplayMode[] = "displayMode";

// ModuleData struct
const char kRadioControlData[] = "radioControlData";
const char kClimateControlData[] = "climateControlData";
const char kAudioControlData[] = "audioControlData";
const char kLightControlData[] = "lightControlData";
const char kHmiSettingsControlData[] = "hmiSettingsControlData";
const char kSeatControlData[] = "seatControlData";
// ModuleData struct

const char kHMIAppID[] = "appID";
const char kHmiLevel[] = "hmiLevel";
const char kSysContext[] = "systemContext";
const char kAudioState[] = "audioStreamingState";

// Grid struct
const char kCol[] = "col";
const char kRow[] = "row";
const char kLevel[] = "level";
const char kColspan[] = "colspan";
const char kRowspan[] = "rowspan";
const char kLevelspan[] = "levelspan";

}  //  namespace message_params

namespace enums_value {

// ModuleType enum
const char kClimate[] = "CLIMATE";
const char kRadio[] = "RADIO";
const char kSeat[] = "SEAT";
const char kAudio[] = "AUDIO";
const char kLight[] = "LIGHT";
const char kHmiSettings[] = "HMI_SETTINGS";
// ModuleType enum

// RadioBand enum
const char kAM[] = "AM";
const char kFM[] = "FM";
const char kXM[] = "XM";
// RadioBand enum

// RadioState enum
const char kAcquiring[] = "ACQUIRING";
const char kAcquired[] = "ACQUIRED";
const char kMulticast[] = "MULTICAST";
const char kNotFound[] = "NOT_FOUND";
// RadioState enum

// DefrostZone enum
const char kFront[] = "FRONT";
const char kRear[] = "REAR";
const char kAll[] = "ALL";
const char kNone[] = "NONE";
// DefrostZone enum

// TemperatureUnit enum
const char kFahrenheit[] = "FAHRENHEIT";
const char kCelsius[] = "CELSIUS";
// TemperatureUnit enum

// ButtonName enum
const char kACMax[] = "AC_MAX";
const char kAC[] = "AC";
const char kRecirculate[] = "RECIRCULATE";
const char kFanUp[] = "FAN_UP";
const char kFanDown[] = "FAN_DOWN";
const char kTempUp[] = "TEMP_UP";
const char kTempDown[] = "TEMP_DOWN";
const char kDefrostMax[] = "DEFROST_MAX";
const char kDefrost[] = "DEFROST";
const char kDefrostRear[] = "DEFROST_REAR";
const char kUpperVent[] = "UPPER_VENT";
const char kLowerVent[] = "LOWER_VENT";
const char kVolumeUp[] = "VOLUME_UP";
const char kVolumeDown[] = "VOLUME_DOWN";
const char kEject[] = "EJECT";
const char kSource[] = "SOURCE";
const char kShuffle[] = "SHUFFLE";
const char kRepeat[] = "REPEAT";
// ButtonName enum

// ButtonPressMode enum
const char kShortPressAvailable[] = "shortPressAvailable";
const char kLongPressAvailable[] = "longPressAvailable";
const char kUpDownAvailable[] = "upDownAvailable";
// ButtonPressMode enum

// Access mode enum
const char kAutoAllow[] = "AUTO_ALLOW";
const char kAutoDeny[] = "AUTO_DENY";
const char kAskDriver[] = "ASK_DRIVER";
// Access mode enum

}  //  namespace enums_value

}  // namespace rc_rpc_plugin

#endif  // SRC_COMPONENTS_APPLICATION_MANAGER_RPC_PLUGINS_RC_RPC_PLUGIN_INCLUDE_RC_RPC_PLUGIN_RC_MODULE_CONSTANTS_H_
